unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ExtCtrls, StdCtrls,
  DIBType, DIBUltra;

type
  TForm1 = class(TForm)
    board: TPaintBox;
    FileDlg: TOpenDialog;
    FileSav: TSaveDialog;
    Panel1: TPanel;
    Load: TButton;
    Save: TButton;
    Res: TButton;
    ExF: TRadioGroup;
    stat: TButton;
    Sup: TGroupBox;
    LZHCheck: TCheckBox;
    INCCheck: TCheckBox;
    ThumbCheck: TCheckBox;
    procedure LoadClick(Sender: TObject);
    procedure boardPaint(Sender: TObject);
    procedure SaveClick(Sender: TObject);
    procedure ResClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ExFClick(Sender: TObject);
    procedure statClick(Sender: TObject);
    procedure ThumbCheckClick(Sender: TObject);
  private
    { Dclarations prives }
    WidthMin : Integer;
    procedure Common;
    procedure SelfDim(DIB : TDIBUltra);
    procedure WMEraseBkgnd(var m: TWMEraseBkgnd); message WM_ERASEBKGND;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  DIB  : TDIBUltra = nil;

implementation

uses Unit2, Unit3;

{$R *.DFM}

{$R IMAGE.RES} // Add the "Pingouin" Image resource

// From TBitmap example : WinHelp of Delphi (Borland)
// comme toute la fiche va tre dessine, la gestion de ce message
// vite les raffichages inutiles de l'arrire-plan
// qui peuvent provoquer des sautillements.
procedure TForm1.WMEraseBkgnd(var m : TWMEraseBkgnd);
begin
  m.Result := LRESULT(False);
end;

procedure TForm1.LoadClick(Sender: TObject);
begin
  FileDlg.InitialDir := ExtractFileDir(Application.ExeName);
  If (Not FileDlg.Execute) Then Exit;
  if (DIB<>nil) Then DIB.Free;
  DIB := TDIBUltra.CreateFromFile(FileDlg.FileName);
  Save.Enabled := True;
  LZHCheck.Enabled := True;
  Common;
//  MessageDlg('File Loaded.', mtInformation,[mbOk], 0);
end;

procedure TForm1.ResClick(Sender: TObject);
begin
  if (DIB<>nil) Then DIB.Free;
  DIB := TDIBUltra.CreateFromResourceName(HInstance, 'Pingouin');
  Common;
//  MessageDlg('Ressource Loaded !', mtInformation,[mbOk], 0);
end;

procedure TForm1.Common;
begin
  Exf.ItemIndex := Ord(DIB.PixelFormat);
  Invalidate;
  SelfDim(DIB);
  With Form3 DO If ThumbCheck.Checked Then
  Begin
    If (Visible) Then FormShow (nil)
                 Else Visible := True;
    FormPaint(nil);
  End;
end;

const
WidthMax  = 600;
HeightMax = 500;

procedure TForm1.SelfDim(DIB : TDIBUltra);
var W,H : Integer;
Begin
  W := DIB.Width;
  H := DIB.Height + Panel1.Height;
  If (W> WidthMax ) Then W := WidthMax;
  If (W< WidthMin ) Then W := WidthMin;
  If (H> HeightMax) Then H := HeightMax;
  Self.ClientWidth  := W;
  Self.ClientHeight := H;
End;

procedure TForm1.boardPaint(Sender: TObject);
var R : TRect;
begin
  If (DIB=nil) Then
  Begin
    Brush.Color := ClBlue;
    Board.Canvas.FillRect(Board.ClientRect);
    Exit
  End;
  R := Rect((Board.Width-DIB.Width) div 2, (Board.Height-DIB.Height) div 2,DIB.Width, DIB.Height);
  DIB.DrawOn(R,Board.Canvas, 0, 0);
  // On encadre l'image par du gris :
  With Board.Canvas Do Begin
    Brush.Color := ClGray;
    If (R.Left>0) Then Begin
      FillRect(Rect(0,0,R.Left, Board.Height));
      FillRect(Rect((R.Left + R.Right),0, Board.Width, Board.Height));
    End;
    If (R.Top>0) Then Begin
      FillRect(Rect(R.Left,0,(R.Left+R.Right), R.Top));
      FillRect(Rect(R.Left,(R.Top + R.Bottom), (R.Left + R.Right), Board.Height));
    End;
  End;
end;

procedure TForm1.SaveClick(Sender: TObject);
var S, TmpS : String;
begin
  If (DIB<>nil)
    Then Begin
      S := Copy(FileDlg.FileName,0,Length(FileDlg.FileName)-3)+'udc';
      FileSav.InitialDir := ExtractFileDir(S);
      FileSav.FileName   := ExtractFileName(S);
      If (Not FileSav.Execute) Then Exit;
      S    := FileSav.FileName;
      TmpS := LowerCase(Copy(S,Length(S)-3,4));
      If (TmpS<>'.udc') Then S := S + '.udc';
      DIB.LZHFormat := LZHCheck.Checked;
      DIB.SaveToFile(S,DUsmDIBUltra, TDUPixelFormat(Exf.ItemIndex));
      MessageDlg('File Written !', mtInformation,[mbOk], 0);
    End
    Else Begin
      Save.Enabled := False;
      LZHCheck.Enabled := False;
    End;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  WidthMin := ClientWidth;
  Application.ShowHint := True;
end;

procedure TForm1.ExFClick(Sender: TObject);
begin
  If (Exf.ItemIndex<Ord(DIB.PixelFormat))
    Then Exf.ItemIndex := Ord(DIB.PixelFormat);
end;

procedure TForm1.statClick(Sender: TObject);
begin
  StatForm.Show;
end;

procedure TForm1.ThumbCheckClick(Sender: TObject);
begin
  If Not ThumbCheck.Checked AND Form3.Visible Then Form3.Close;
  If (DIB=nil) Then Exit;
  If ThumbCheck.Checked AND Not Form3.Visible Then Form3.Show;
end;

end.







