unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DIBCoDec, ExtCtrls;

type
  TStatForm = class(TForm)
    Board: TPaintBox;
    procedure BoardPaint(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  StatForm: TStatForm;
  STAT : array [Byte] of LongInt;

procedure INCFilter ( Pt : Pointer ; Width, Height : Integer ; ToDo : Boolean );

implementation

uses unit1;

{$R *.DFM}

procedure TStatForm.BoardPaint(Sender: TObject);
var
  n, S : integer;
  C : ^Byte;
begin
  If (DIB=nil) Then Exit;
  S := 0;
  With Board.Canvas Do Begin
    // Sans le filtre
    C := DIB.BITs;
    For n := 0 to 255 Do STAT[n] := 0;
    For n := 0 To DIB.Size-1 Do Begin
      Inc(STAT[C^]); Inc(C);
    End;
    For n := 0 to 255 Do Inc (S, STAT[n]);
    Pen.Width := 2;
    // Ligne de sparation
    Pen.Color := ClRed; MoveTo(0, 0); LineTo(512, 0);
    Pen.Color := ClWhite;
    For n := 0 to 255 Do Begin
      MoveTo(n * 2, 200);
      LineTo(n * 2, 200 - Round(STAT[n] / S * 1600));
    End;
    Font.Color := ClYellow;
    TextOut(100, 5, 'DISTRIBUTION des densits (non filtrs)');
    // Appel du filtre
  If (DIB.Bpp<>24) Then Exit;
  INCFilter ( DIB.Bits , DIB.Width, DIB.Height, True);
    // Avec le filtre
    C := DIB.BITs;
    For n := 0 to 255 Do STAT[n] := 0;
    For n := 0 To DIB.Size-1 Do Begin
      Inc(STAT[C^]); Inc(C);
    End;
    For n := 0 to 255 Do Inc (S, STAT[n]);
    Pen.Width := 2;
    // Ligne de sparation
    Pen.Color := ClRed; MoveTo(0, 210); LineTo(512, 210);
    Pen.Color := ClWhite;
    For n := 0 to 255 Do Begin
      MoveTo(n * 2, 410);
      LineTo(n * 2, 410 - Round(STAT[n] / S * 1600));
    End;
    TextOut(100, 215, 'DISTRIBUTION des densits (filtres par INC)');
  End;
    // Appel du filtre
  INCFilter ( DIB.Bits , DIB.Width, DIB.Height, False);
end;

Type
  P = Pointer;
  I = Integer;

// INCFilter : just for statistics uses ...  
procedure INCFilter ( Pt : Pointer ; Width, Height : Integer ; ToDo : Boolean );
var
  X, Y, XInc  : Integer;
  W3          : Integer;
  YCur        : Pointer;
  pR, pV, pB  : ^Byte;   // Pointer to RVB values
  lR, lV, lB  :  Byte;   // Last RVB Value
  Buf         :  Byte;
Begin
  // Cette optimisation est intressante uniquement pour le mode 24 bpp !
  W3    := (Width * 3);
  XInc  := (W3 + 3) AND NOT $3;  // Width_b
  // (en mmoire) faire [ la drive / l'incrmentation ] pour R, V, B :
  YCur  := Pt;
  For Y := 0 To (Height-1) Do Begin
    pR  := YCur; pV := P(I(pR) + 1); pB := P(I(pV) + 1);
    lR  := 0; lV := 0; lB := 0; // En dbut de ligne, on recommence en absolue !
    If ToDo Then
      For X := 0 To (Width-1) Do Begin // A mettre
        Buf := 127 + pR^ - lR; lR := pR^; pR^:= Buf; Inc(pR, 3);
        Buf := 127 + pV^ - lV; lV := pV^; pV^:= Buf; Inc(pV, 3);
        Buf := 127 + pB^ - lB; lB := pB^; pB^:= Buf; Inc(pB, 3);
      End
    Else
      For X := 0 To (Width-1) Do Begin // A enlever
        lR := pR^ + lR - 127 ; pR^ := lR; Inc(pR, 3);
        lV := pV^ + lV - 127 ; pV^ := lV; Inc(pV, 3);
        lB := pB^ + lB - 127 ; pB^ := lB; Inc(pB, 3);
      End;
  YCur  := P(I(Pt) + XInc * Y);
  End;
End;

end.
