unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DIBType, DIBUltra;

type
  TForm3 = class(TForm)
    procedure FormPaint(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    Thumb : TDIBUltra;
  end;

var
  Form3: TForm3;

implementation

uses unit1, Resample;

{$R *.DFM}

procedure TForm3.FormPaint(Sender: TObject);
var
  R   : TRect;
begin
// Affichage
  If (Thumb=nil) Then Exit;
  R := Rect((ClientWidth-Thumb.Width) div 2, (ClientHeight-Thumb.Height) div 2,
             Thumb.Width, Thumb.Height);
  Thumb.DrawOn(R,Canvas, 0, 0);
  // On encadre l'image par du gris :
  With Canvas Do Begin
    Brush.Color := ClGray;
    If (R.Left>0) Then Begin
      FillRect(Rect(0,0,R.Left, ClientHeight));
      FillRect(Rect((R.Left + R.Right),0, ClientWidth, ClientHeight));
    End;
    If (R.Top>0) Then Begin
      FillRect(Rect(R.Left,0,(R.Left+R.Right), R.Top));
      FillRect(Rect(R.Left,(R.Top + R.Bottom), (R.Left + R.Right), ClientHeight));
    End;
  End;
  // Cadre
  Canvas.Brush.Color := ClWhite;
  Inc (R.Right,  R.Left);
  Inc (R.Bottom, R.Top);
  Canvas.FrameRect(R);
End;

procedure TForm3.FormShow(Sender: TObject);
const
  MAXTHUMB = 100;
  DIVTHUMB = 5;
type RVB = packed record R,V,B : Byte End;
var
  x,y : integer;
  Val : ^RVB;
  NWdt: Integer;
  NHgt: Integer;
  Src : TDIBUltra;
begin
  If (Thumb<>nil) Then Thumb.Free;
  If (DIB=nil) Then Exit;
// Calcul de NWdt & NHgt
  NWdt := DIB.Width  div DIVTHUMB;
  NHgt := DIB.Height div DIVTHUMB;
  If (NWdt=0)OR(NHgt=0) Then Exit; // Thumb sans largeur/hauteur !
  If (NWdt>MAXTHUMB) Then
  Begin
    NHgt := NHgt * MAXTHUMB div NWdt;
    NWdt := MAXTHUMB;
  End;
  If (NHgt>MAXTHUMB) Then
  Begin
    NWdt := NWdt * MAXTHUMB div NHgt;
    NHgt := MAXTHUMB;
  End;
  If (NWdt=0)OR(NHgt=0) Then Exit; // Thumb sans largeur/hauteur !
  Thumb := TDIBUltra.Create(NWdt, NHgt, DUpf24, nil);
{ // SEB Message : The Windows Stretch seems to be
  // buggy : with one of my test BMP, the Thumb DIB is black filled ? !
  // (It is a large DIB : 11 Mo in 24 bpp)
  SetStretchBltMode(Thumb.Canvas.Handle, HALFTONE);
  Thumb.Canvas.CopyRect(Thumb.ClipRect, DIB.Canvas, DIB.ClipRect);
}
  If (DIB.Bpp <> 24) Then Begin
    Src := TDIBUltra.Create(DIB.Width, DIB.Height, DUpf24, nil);
    DIB.DrawOn(Src.ClipRect, Src.Canvas, 0, 0 );
  End Else Src := DIB;

  Strecth(Src, Thumb, HermiteFilter, 1.0);

  If (DIB.Bpp <> 24) Then Src.Free;

// Reduction Chromatique :
  For y := 0 to Thumb.Height-1 Do Begin
    Val := Thumb.ScanLine[y];
    For x := 0 To Thumb.Width-1 Do Begin
      Val.R := Val.R AND $F0;
      Val.V := Val.V AND $F0;
      Val.B := Val.B AND $F0;
      Inc(Val);
    End;
  End;
// Mise  jour des dimensions de la feuille :
  ClientWidth  := NWdt + 30;
  ClientHeight := NHgt + 30;

end;

procedure TForm3.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  If (Thumb<>nil) Then Thumb.Free;
  Thumb := Nil;
  Form1.ThumbCheck.Checked := False;
end;

procedure TForm3.FormResize(Sender: TObject);
begin
  FormPaint(Self);
end;

procedure TForm3.FormCreate(Sender: TObject);
begin
  Thumb := nil;
end;

End.
