unit Splash;

interface

uses
  Windows, Messages, Graphics, Extctrls, Forms, Classes,
  DIBUltra, DIBType;

type
TState = (Up, Down, Finished);

TSplashForm = class(TForm)
    procedure FormPaint(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
  private
    { Dclarations prives }
    Motif : TDIBUltra;
    Dest  : TDIBUltra;
    Fond  : TDIBUltra;
    Alpha : Integer; // de 0  32 puis de 32  0; (densit du Blend)
    REOrg : TPoint;
    Tm    : TTimer;
    procedure ChangeSplash( Obj : TObject );
    procedure WMEraseBkgnd(var m: TWMEraseBkgnd); message WM_ERASEBKGND;
  public
    { Dclarations publiques }
    State : TState;
  end;

var ScreenSplash : TSplashForm;

implementation

{$R *.DFM}

// From TBitmap example : WinHelp of Delphi (Borland)
// comme toute la fiche va tre dessine, la gestion de ce message
// vite les raffichages inutiles de l'arrire-plan
// qui peuvent provoquer des sautillements.
procedure TSplashForm.WMEraseBkgnd(var m : TWMEraseBkgnd);
begin
  m.Result := LRESULT(False);
end;

procedure TSplashForm.FormPaint(Sender: TObject);
begin
//  Canvas.CopyRect(ClientRect,Dest.Canvas,Rect(0,0,ClientWidth,ClientHeight));
// Utilise plutt :
  Dest.DrawOn(ClientRect,Canvas,0,0); // C'est fait pour cela DrawOn ! (avec un BitBlit)
  // Dest est  tout moment valide !
end;

procedure TSplashForm.ChangeSplash( Obj : TObject );
// la suite logique pour Alpha est :
// 0 (dbut) 1 .. 31 (AlphaBlend monte) 32..45 (reste) 46  31..0 (AlphaBlend Descend) -1 (Fini)
Begin
  Case Alpha Of
    -1    : Begin State := Finished; Tm.Enabled := False End; // Fin de l'animation !
    0..31 : Begin
              Motif.DrawOn(ClientRect, Dest.Canvas, 0,0);
              Fond.AlphaBlit(Dest,0,0,Alpha);
              If (State=Up) Then Inc(Alpha) Else Dec(Alpha);
              FormPaint(Self);
            End;
    32..45: Inc(Alpha); // Et passe le temps
    46    : Begin State := Down; Alpha := 31 End;
  End;
End;

procedure TSplashForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//  TabEcrans[ECRAN_ANIM_ENTREE]^.Show;  // Je ne sais pas  quoi cela se rapporte
  { on ferme dfinitivement la fiche }
  Tm.Free;
  Motif.Free;
  Dest.Free;
//  Release; // Pas besoin : tu fais un Free dans le dpr
end;

procedure TSplashForm.FormShow(Sender: TObject);
var
  ScreenDC: HDC;      // This will let us access the 'desktop'.

begin
  Motif        := TDIBUltra.CreateFromFile('Logo.udc'); // Remplie par le motif
  Dest         := TDIBUltra.Create(Motif.Width, Motif.Height, DUpf16, nil); // Utilise pour placer le fond
  Fond         := TDIBUltra.Create(Motif.Width, Motif.Height, DUpf16, nil); // Utilise pour placer le fond
  ClientWidth  := Motif.Width;
  ClientHeight := Motif.Height;
  Left         := (Screen.Height - ClientHeight) div 2; // Au milieu
  Top          := (Screen.Width  - ClientWidth ) div 2;
  Alpha        := 0;
  State        := Up;
  Tm           := TTimer.Create(Self);
  Tm.Enabled   := False; // pour tre sr
  Tm.Interval  := 40;    // 40 millisecondes : OK
  Tm.OnTimer   := ChangeSplash;

  // On convertit les coordonnes dans la form en coordonnes relatives  l'cran.
  REOrg := ClientToScreen(Point(0,0));
  // Allow access to the desktop:
  ScreenDC:=GetDC(0);

  Try // Le try protge le DC de non destruction, pas la peine de le placer avant sa cration !
    // Copy the desktop area under the form, to our image:
    BitBlt(Fond.Canvas.Handle,0,0,ClientWidth,ClientHeight,ScreenDC,REOrg.x, REOrg.y, SRCCOPY);
  finally
    // Release the desktop DC again:
    ReleaseDC(0, ScreenDC);
  end;
  Fond.DrawOn(ClientRect, Dest.Canvas, 0,0);
  Motif.AlphaChanelBlit(Fond,0,0,1);
  Motif.MakeOpaque; // On libre l'Alpha Chanel
  Dest.DrawOn(ClientRect, Motif.Canvas, 0,0);
  // Motif est l'image du desktop initial
  // Fond  est l'image du desktop avec l'incrustation (AlphaChanelBlend)
  // Dest  est l'image en cours de traitement (AlphaBlend)
  Tm.Enabled   := True; // Go !
end;

end.
